#ifndef	PEXEXT_H
#define	PEXEXT_H
 
/* Common Open Systems Environment, Common Graphics Environment  */		
/* Extension to PEX 5.1 version 2.  File date: March 30, 1994    */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN	MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD	TO THIS	      */
/*  SOFTWARE, INCLUDING	ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT	SHALL SUN MICROSYSTEMS,	INC. BE	LIABLE FOR ANY SPECIAL,	      */
/*  INDIRECT OR	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER	RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER	TORTIOUS ACTION, ARISING OUT OF	OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE	OF THIS	SOFTWARE.			      */
/*									      */
/******************************************************************************/

/*
 * Extended Enumerated Types
 */
#define	PEXExtETEnumType			(PEXEnumTypeIndex) 0x9000
#define	PEXExtETOC				(PEXEnumTypeIndex) 0x9001
#define	PEXExtETPC				(PEXEnumTypeIndex) 0x9002
#define	PEXExtETRA				(PEXEnumTypeIndex) 0x9003
#define	PEXExtETLUT				(PEXEnumTypeIndex) 0x9004
#define	PEXExtETID				(PEXEnumTypeIndex) 0x9005
#define	PEXExtETTMRenderingOrder		(PEXEnumTypeIndex) 0x9006
#define	PEXExtETTMCoordSource			(PEXEnumTypeIndex) 0x9007
#define	PEXExtETTMCompositeMethod		(PEXEnumTypeIndex) 0x9008
#define	PEXExtETTMTexelSampleMethod		(PEXEnumTypeIndex) 0x9009
#define	PEXExtETTMBoundaryCondition		(PEXEnumTypeIndex) 0x900A
#define	PEXExtETTMClampColorSource		(PEXEnumTypeIndex) 0x900B
#define	PEXExtETTMDomain			(PEXEnumTypeIndex) 0x900C
#define	PEXExtETTexelType			(PEXEnumTypeIndex) 0x900D
#define	PEXExtETTMResourceHint			(PEXEnumTypeIndex) 0x900E
#define	PEXExtETTMType				(PEXEnumTypeIndex) 0x900F
#define	PEXExtETTMParameterizationMethod	(PEXEnumTypeIndex) 0x9010
#define	PEXExtETTMPerspectiveCorrection		(PEXEnumTypeIndex) 0x9011
#define	PEXExtETTMSampleFrequency		(PEXEnumTypeIndex) 0x9012
#define	PEXExtETPrimitiveAAMode			(PEXEnumTypeIndex) 0x9013
#define	PEXExtETPrimitiveAABlendOp		(PEXEnumTypeIndex) 0x9014
#define	PEXExtETLineCapStyle			(PEXEnumTypeIndex) 0x9015
#define	PEXExtETLineJoinStyle			(PEXEnumTypeIndex) 0x9016

/* Extended Enumerated Types Mnemonics */
#define	PEXExtETMEnumType			"ExtEnumType"
#define	PEXExtETMOC				"ExtOC"
#define	PEXExtETMPC				"ExtPC"
#define	PEXExtETMRA				"ExtRA"
#define	PEXExtETMLUT				"ExtLUT"
#define	PEXExtETMID				"ExtID"
#define	PEXExtETMTMRenderingOrder		"ExtTMRenderingOrder"
#define	PEXExtETMTMCoordSource			"ExtTMCoordSource"
#define	PEXExtETMTMCompositeMethod		"ExtTMCompositeMethod"
#define	PEXExtETMTMTexelSampleMethod		"ExtTMTexelSampleMethod"
#define	PEXExtETMTMBoundaryCondition		"ExtTMBoundaryCondition"
#define	PEXExtETMTMClampColorSource		"ExtTMClampColorSource"
#define	PEXExtETMTMDomain			"ExtTMDomain"
#define	PEXExtETMTexelType			"ExtTexelType"
#define	PEXExtETMTMResourceHint			"ExtTMResourceHint"
#define	PEXExtETMTMType				"ExtTMType"
#define	PEXExtETMTMParameterizationMethod	"ExtTMParameterizationMethod"
#define	PEXExtETMTMPerspectiveCorrection	"ExtTMPerspectiveCorrection"
#define	PEXExtETMTMSampleFrequency		"ExtTMSampleFrequency"
#define	PEXExtETMPrimitiveAAMode		"ExtPrimitiveAAMode"
#define	PEXExtETMPrimitiveAABlendOp		"ExtPrimitiveAABlendOp"
#define	PEXExtETMLineCapStyle			"ExtLineCapStyle"
#define	PEXExtETMLineJoinStyle			"ExtLineJoinStyle"

/*
 * Extended Enumerated Values
 */
/* Extended Output Commands */
#define	PEXExtOCTMPerspectiveCorrection		(PEXEnumTypeIndex) 0x9000
#define	PEXExtOCTMSampleFrequency		(PEXEnumTypeIndex) 0x9001
#define	PEXExtOCTMResourceHints			(PEXEnumTypeIndex) 0x9002
#define	PEXExtOCActiveTextures			(PEXEnumTypeIndex) 0x9003
#define	PEXExtOCBFActiveTextures		(PEXEnumTypeIndex) 0x9004
#define	PEXExtOCFillAreaSetWithData		(PEXEnumTypeIndex) 0x9005
#define	PEXExtOCSetOfFillAreaSets		(PEXEnumTypeIndex) 0x9006
#define	PEXExtOCTriangleStrip			(PEXEnumTypeIndex) 0x9007
#define	PEXExtOCQuadrilateralMesh		(PEXEnumTypeIndex) 0x9008
#define	PEXExtOCPrimitiveAA			(PEXEnumTypeIndex) 0x9009
#define	PEXExtOCLineCapStyle			(PEXEnumTypeIndex) 0x900A
#define	PEXExtOCLineJoinStyle			(PEXEnumTypeIndex) 0x900B
#define	PEXExtOCEllipse				(PEXEnumTypeIndex) 0x900C
#define	PEXExtOCEllipse2D			(PEXEnumTypeIndex) 0x900D
#define	PEXExtOCCircle2D			(PEXEnumTypeIndex) 0x900E
#define	PEXExtOCEllipticalArc			(PEXEnumTypeIndex) 0x900F
#define	PEXExtOCEllipticalArc2D			(PEXEnumTypeIndex) 0x9010
#define	PEXExtOCCircularArc2D			(PEXEnumTypeIndex) 0x9011

/* Extended Output Commands Mnemonics */
#define	PEXExtETMOCTMPerspectiveCorrection	"ExtOCTMPerspectiveCorrection"
#define	PEXExtETMOCTMSampleFrequency		"ExtOCTMSampleFrequency"
#define	PEXExtETMOCTMResourceHints		"ExtOCTMResourceHints"
#define	PEXExtETMOCActiveTextures		"ExtOCActiveTextures"
#define	PEXExtETMOCBFActiveTextures		"ExtOCBFActiveTextures"
#define	PEXExtETMOCFillAreaSetWithData		"ExtOCFillAreaSetWithData"
#define	PEXExtETMOCSetOfFillAreaSets		"ExtOCSetOfFillAreaSets"
#define	PEXExtETMOCTriangleStrip		"ExtOCTriangleStrip"
#define	PEXExtETMOCQuadrilateralMesh		"ExtOCQuadrilateralMesh"
#define	PEXExtETMOCPrimitiveAA			"ExtOCPrimitiveAA"
#define	PEXExtETMOCLineCapStyle			"ExtOCLineCapStyle"
#define	PEXExtETMOCLineJoinStyle		"ExtOCLineJoinStyle"
#define	PEXExtETMOCEllipse			"ExtOCEllipse"
#define	PEXExtETMOCEllipse2D			"ExtOCEllipse2D"
#define	PEXExtETMOCCircle2D			"ExtOCCircle2D"
#define	PEXExtETMOCEllipticalArc		"ExtOCEllipticalArc"
#define	PEXExtETMOCEllipticalArc2D		"ExtOCEllipticalArc2D"
#define	PEXExtETMOCCircularArc2D		"ExtOCCircularArc2D"

/* Extended PC Attributes (also	used as	PC Bitmask Constants) */
#define	PEXExtPCMinShift			(PEXEnumTypeIndex) 0x9000
#define	PEXExtPCTMPerspectiveCorrection		(PEXEnumTypeIndex) 0x9000
#define	PEXExtPCTMResourceHints			(PEXEnumTypeIndex) 0x9001
#define	PEXExtPCTMSampleFrequency		(PEXEnumTypeIndex) 0x9002
#define	PEXExtPCActiveTextures			(PEXEnumTypeIndex) 0x9003
#define	PEXExtPCBFActiveTextures		(PEXEnumTypeIndex) 0x9004
#define	PEXExtPCPrimitiveAA			(PEXEnumTypeIndex) 0x9005
#define	PEXExtPCLineCapStyle			(PEXEnumTypeIndex) 0x9006
#define	PEXExtPCLineJoinStyle			(PEXEnumTypeIndex) 0x9007
#define	PEXExtPCMaxShift			(PEXEnumTypeIndex) 0x9007

/* Extended PC Attributes Mnemonics */
#define	PEXExtETMPCTMPerspectiveCorrection	"ExtPCTMPerspectiveCorrection"
#define	PEXExtETMPCTMResourceHints		"ExtPCTMResourceHints"
#define	PEXExtETMPCTMSampleFrequency		"ExtPCTMSampleFrequency"
#define	PEXExtETMPCActiveTextures		"ExtPCActiveTextures"
#define	PEXExtETMPCBFActiveTextures		"ExtPCBFActiveTextures"
#define	PEXExtETMPCPrimitiveAA			"ExtPCPrimitiveAA"
#define	PEXExtETMPCLineCapStyle			"ExtPCLineCapStyle"
#define	PEXExtETMPCLineJoinStyle		"ExtPCLineJoinStyle"

/* Extended Renderer Attributes	(as used as RA Bitmask Constants) */
#define	PEXExtRAMinShift			(PEXEnumTypeIndex) 0x9000
#define	PEXExtRATMBindingTable			(PEXEnumTypeIndex) 0x9000
#define	PEXExtRATMCoordSourceTable		(PEXEnumTypeIndex) 0x9001
#define	PEXExtRATMCompositionTable		(PEXEnumTypeIndex) 0x9002
#define	PEXExtRATMSamplingTable			(PEXEnumTypeIndex) 0x9003
#define	PEXExtRAMaxShift			(PEXEnumTypeIndex) 0x9003

/* Extended Renderer Attributes	Mnemonics */
#define	PEXExtETMRATMBindingTable		"ExtRATMBindingTable"
#define	PEXExtETMRATMCoordSourceTable		"ExtRATMCoordSourceTable"
#define	PEXExtETMRATMCompositionTable		"ExtRATMCompositionTable"
#define	PEXExtETMRATMSamplingTable		"ExtRATMSamplingTable"
 
/* Extended Lookup Tables */
#define	PEXExtLUTTMBinding			(PEXEnumTypeIndex) 0x9000
#define	PEXExtLUTTMCoordSource			(PEXEnumTypeIndex) 0x9001
#define	PEXExtLUTTMComposition			(PEXEnumTypeIndex) 0x9002
#define	PEXExtLUTTMSampling			(PEXEnumTypeIndex) 0x9003

/* Extended Lookup Tables Mnemonics */
#define	PEXExtETMLUTTMBinding			"ExtLUTTMBinding"
#define	PEXExtETMLUTTMCoordSource		"ExtLUTTMCoordSource"
#define	PEXExtETMLUTTMComposition		"ExtLUTTMComposition"
#define	PEXExtETMLUTTMSampling			"ExtLUTTMSampling"
 
/* Extended Implementation-Dependent Constants */
#define	PEXExtIDMaxTextureMaps			(PEXEnumTypeIndex) 0x9000
#define	PEXExtIDMaxFastTMSize			(PEXEnumTypeIndex) 0x9001
#define	PEXExtIDPowerOfTwoTMSizesRequired	(PEXEnumTypeIndex) 0x9002
#define	PEXExtIDSquareTMRequired		(PEXEnumTypeIndex) 0x9003

/* Extended Implementation-Dependent Constants Mnemonics */
#define	PEXExtETMIDMaxTextureMaps		"ExtIDMaxTextureMaps"
#define	PEXExtETMIDMaxFastTMSize		"ExtIDMaxFastTMSize"
#define	PEXExtETMIDPowerOfTwoTMSizesRequired	"ExtIDPowerOfTwoTMSizesRequired"
#define	PEXExtETMIDSquareTMRequired		"ExtIDSquareTMRequired"
 
/* Texture Mapping Rendering Order */
#define	PEXExtTMRenderingOrderPreSpecular	(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMRenderingOrderPostSpecular	(PEXEnumTypeIndex) 0x9001

/* Texture Mapping Rendering Order Mnemonics */
#define	PEXExtETMTMRenderingOrderPreSpecular	"ExtTMRenderingOrderPreSpecular"
#define	PEXExtETMTMRenderingOrderPostSpecular	"ExtTMRenderingOrderPostSpecular"

/* Texture Mapping Coordinate Source */
#define	PEXExtTMCoordSourceVertexCoord		(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMCoordSourceVertexNormal		(PEXEnumTypeIndex) 0x9001
#define	PEXExtTMCoordSourceFloatData		(PEXEnumTypeIndex) 0x9002

/* Texture Mapping Coordinate Source Mnemonics */
#define	PEXExtETMTMCoordSourceVertexCoord	"ExtTMCoordSourceVertexCoord"
#define	PEXExtETMTMCoordSourceVertexNormal	"ExtTMCoordSourceVertexNormal"
#define	PEXExtETMTMCoordSourceFloatData		"ExtTMCoordSourceFloatData"
 
/* Texture Mapping Composite Method */
#define	PEXExtTMCompositeReplace		(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMCompositeModulate		(PEXEnumTypeIndex) 0x9001
#define	PEXExtTMCompositeBlendEnvColor		(PEXEnumTypeIndex) 0x9002
#define	PEXExtTMCompositeDecal			(PEXEnumTypeIndex) 0x9003
#define	PEXExtTMCompositeDecalBackground	(PEXEnumTypeIndex) 0x9004
#define	PEXExtTMCompositeReplaceBlendedColors	(PEXEnumTypeIndex) 0x9005

/* Texture Mapping Composite Method Mnemonics */
#define	PEXExtETMTMCompositeReplace		"ExtTMCompositeReplace"
#define	PEXExtETMTMCompositeModulate		"ExtTMCompositeModulate"
#define	PEXExtETMTMCompositeBlendEnvColor	"ExtTMCompositeBlendEnvColor"
#define	PEXExtETMTMCompositeDecal		"ExtTMCompositeDecal"
#define	PEXExtETMTMCompositeDecalBackground	"ExtTMCompositeDecalBackground"
#define	PEXExtETMTMCompositeReplaceBlendedColors "ExtTMCompositeReplaceBlendedColors"
 
/* Texture Mapping Texel Sample	Method */
#define	PEXExtTMTexelSampleSingleBase		(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMTexelSampleLinearBase		(PEXEnumTypeIndex) 0x9001
#define	PEXExtTMTexelSampleSingleInMipmap	(PEXEnumTypeIndex) 0x9002
#define	PEXExtTMTexelSampleLinearInMipmap	(PEXEnumTypeIndex) 0x9003
#define	PEXExtTMTexelSampleSingleBetweenMipmaps	(PEXEnumTypeIndex) 0x9004
#define	PEXExtTMTexelSampleLinearBetweenMipmaps	(PEXEnumTypeIndex) 0x9005

/* Texture Mapping Texel Sample	Method Mnemonics */
#define	PEXExtETMTMTexelSampleSingleBase	"ExtTMTexelSampleSingleBase"
#define	PEXExtETMTMTexelSampleLinearBase	"ExtTMTexelSampleLinearBase"
#define	PEXExtETMTMTexelSampleSingleInMipmap	"ExtTMTexelSampleSingleInMipmap"
#define	PEXExtETMTMTexelSampleLinearInMipmap	"ExtTMTexelSampleLinearInMipmap"
#define	PEXExtETMTMTexelSampleSingleBetweenMipmaps "ExtTMTexelSampleSingleBetweenMipmaps"
#define	PEXExtETMTMTexelSampleLinearBetweenMipmaps "ExtTMTexelSampleLinearBetweenMipmaps"
 
/* Texture Mapping Boundary Condition */
#define	PEXExtTMBoundaryCondClampColor		(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMBoundaryCondBoundary     	(PEXEnumTypeIndex) 0x9001
#define	PEXExtTMBoundaryCondWrap		(PEXEnumTypeIndex) 0x9002
#define	PEXExtTMBoundaryCondMirror		(PEXEnumTypeIndex) 0x9003

/* Texture Mapping Boundary Condition Mnemonics	*/
#define	PEXExtETMTMBoundaryCondClampColor	"ExtTMBoundaryCondClampColor"
#define	PEXExtETMTMBoundaryCondBoundary      "ExtTMBoundaryCondBoundary"
#define	PEXExtETMTMBoundaryCondWrap	"ExtTMBoundaryCondWrap"
#define	PEXExtETMTMBoundaryCondMirror	"ExtTMBoundaryCondMirror"

 
/* Texture Mapping Boundary Condition Clamp Color Source */
#define	PEXExtTMClampColorSourceAbsolute	(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMClampColorSourceExplicit	(PEXEnumTypeIndex) 0x9001

/* Texture Mapping Boundary Condition Clamp Color Source Mnemonics */
#define	PEXExtETMTMClampColorSourceAbsolute	"ExtTMClampColorSourceAbsolute"
#define	PEXExtETMTMClampColorSourceExplicit	"ExtTMClampColorSourceExplicit"
 
/* Texture Mapping Domain */
#define	PEXExtTMDomainColor1D			(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMDomainColor2D			(PEXEnumTypeIndex) 0x9001
#define	PEXExtTMDomainColor3D			(PEXEnumTypeIndex) 0x9002

/* Texture Mapping Domain Mnemonics */
#define	PEXExtETMTMDomainColor1D		"ExtTMDomainColor1D"
#define	PEXExtETMTMDomainColor2D		"ExtTMDomainColor2D"
#define	PEXExtETMTMDomainColor3D		"ExtTMDomainColor3D"
 
/* Texel Type */
#define	PEXExtTexelLuminanceFloat		(PEXEnumTypeIndex) 0x9000
#define	PEXExtTexelLuminanceInt8		(PEXEnumTypeIndex) 0x9001
#define	PEXExtTexelLuminanceInt16		(PEXEnumTypeIndex) 0x9002
#define	PEXExtTexelLuminanceAlphaFloat		(PEXEnumTypeIndex) 0x9003
#define	PEXExtTexelLuminanceAlphaInt8		(PEXEnumTypeIndex) 0x9004
#define	PEXExtTexelLuminanceAlphaInt16		(PEXEnumTypeIndex) 0x9005
#define	PEXExtTexelRGBFloat			(PEXEnumTypeIndex) 0x9006
#define	PEXExtTexelRGBInt8			(PEXEnumTypeIndex) 0x9007
#define	PEXExtTexelRGBInt16			(PEXEnumTypeIndex) 0x9008
#define	PEXExtTexelRGBAlphaFloat		(PEXEnumTypeIndex) 0x9009
#define	PEXExtTexelRGBAlphaInt8			(PEXEnumTypeIndex) 0x900A
#define	PEXExtTexelRGBAlphaInt16		(PEXEnumTypeIndex) 0x900B

/* Texel Type Mnemonics	*/
#define	PEXExtETMTexelLuminanceFloat		"ExtTexelLuminanceFloat"
#define	PEXExtETMTexelLuminanceInt8		"ExtTexelLuminanceInt8"
#define	PEXExtETMTexelLuminanceInt16		"ExtTexelLuminanceInt16"
#define	PEXExtETMTexelLuminanceAlphaFloat	"ExtTexelLuminanceAlphaFloat"
#define	PEXExtETMTexelLuminanceAlphaInt8	"ExtTexelLuminanceAlphaInt8"
#define	PEXExtETMTexelLuminanceAlphaInt16	"ExtTexelLuminanceAlphaInt16"
#define	PEXExtETMTexelRGBFloat			"ExtTexelRGBFloat"
#define	PEXExtETMTexelRGBInt8			"ExtTexelRGBInt8"
#define	PEXExtETMTexelRGBInt16			"ExtTexelRGBInt16"
#define	PEXExtETMTexelRGBAlphaFloat		"ExtTexelRGBAlphaFloat"
#define	PEXExtETMTexelRGBAlphaInt8		"ExtTexelRGBAlphaInt8"
#define	PEXExtETMTexelRGBAlphaInt16		"ExtTexelRGBAlphaInt16"

/* Texture Mapping Type	*/
#define	PEXExtTMTypeMipMap			(PEXEnumTypeIndex) 0x9000

/* Texture Mapping Type	Mnemonics */
#define	PEXExtETMTMTypeMipMap			"ExtTMTypeMipMap"

/* Texture Mapping Parameterization Method */
#define	PEXExtTMParamExplicit			(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMParamReflectSphereVRC		(PEXEnumTypeIndex) 0x9001
#define	PEXExtTMParamReflectSphereWC		(PEXEnumTypeIndex) 0x9002
#define	PEXExtTMParamLinearVRC			(PEXEnumTypeIndex) 0x9003

/* Texture Mapping Parameterization Method Mnemonics */
#define	PEXExtETMTMParamExplicit		"ExtTMParamExplicit"
#define	PEXExtETMTMParamReflectSphereVRC	"ExtTMParamReflectSphereVRC"
#define	PEXExtETMTMParamReflectSphereWC		"ExtTMParamReflectSphereWC"
#define	PEXExtETMTMParamLinearVRC		"ExtTMParamLinearVRC"
 
/* Texture Mapping Perspective Correction */
#define	PEXExtTMPerspCorrectNone		(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMPerspCorrectVertex		(PEXEnumTypeIndex) 0x9001
#define	PEXExtTMPerspCorrectPixel		(PEXEnumTypeIndex) 0x9002
 
/* Texture Mapping Perspective Correction Mnemonics */
#define	PEXExtETMTMPerspCorrectNone		"ExtTMPerspCorrectNone"
#define	PEXExtETMTMPerspCorrectVertex		"ExtTMPerspCorrectVertex"
#define	PEXExtETMTMPerspCorrectPixel		"ExtTMPerspCorrectPixel"

/* Texture Mapping Sample Frequency */
#define	PEXExtTMSampleFrequencyPixel		(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMSampleFrequencyInterpDep	(PEXEnumTypeIndex) 0x9001
 
/* Texture Mapping Sample Frequency Mnemonics */
#define	PEXExtETMTMSampleFrequencyPixel		"ExtTMSampleFrequencyPixel"
#define	PEXExtETMTMSampleFrequencyInterpDep	"ExtTMSampleFrequencyInterpDep"

/* Texture Mapping Resource Hints */
#define	PEXExtTMResourceHintNone		(PEXEnumTypeIndex) 0x9000
#define	PEXExtTMResourceHintSpeed		(PEXEnumTypeIndex) 0x9001
#define	PEXExtTMResourceHintSpace		(PEXEnumTypeIndex) 0x9002

/* Texture Mapping Resource Hint Mnemonics */
#define	PEXExtETMTMResourceHintNone		"ExtTMResourceHintNone"
#define	PEXExtETMTMResourceHintSpeed		"ExtTMResourceHintSpeed"
#define	PEXExtETMTMResourceHintSpace		"ExtTMResourceHintSpace"

/* Primitive Anti-Aliasing Mode	*/
#define	PEXExtPrimAANone			(PEXEnumTypeIndex) 0x9000
#define	PEXExtPrimAAPoint			(PEXEnumTypeIndex) 0x9001
#define	PEXExtPrimAAVector			(PEXEnumTypeIndex) 0x9002
#define	PEXExtPrimAAPointVector			(PEXEnumTypeIndex) 0x9003
#define	PEXExtPrimAAPolygon			(PEXEnumTypeIndex) 0x9004
#define	PEXExtPrimAAPointPolygon		(PEXEnumTypeIndex) 0x9005
#define	PEXExtPrimAAVectorPolygon		(PEXEnumTypeIndex) 0x9006
#define	PEXExtPrimAAPointVectorPolygon		(PEXEnumTypeIndex) 0x9007

/* Primitive Anti-Aliasing Mode	Mnemonics */
#define	PEXExtETMPrimAANone			"ExtPrimAANone"
#define	PEXExtETMPrimAAPoint			"ExtPrimAAPoint"
#define	PEXExtETMPrimAAVector			"ExtPrimAAVector"
#define	PEXExtETMPrimAAPointVector		"ExtPrimAAPointVector"
#define	PEXExtETMPrimAAPolygon			"ExtPrimAAPolygon"
#define	PEXExtETMPrimAAPointPolygon		"ExtPrimAAPointPolygon"
#define	PEXExtETMPrimAAVectorPolygon		"ExtPrimAAVectorPolygon"
#define	PEXExtETMPrimAAPointVectorPolygon	"ExtPrimAAPointVectorPolygon"

/* Primitive Anti-Aliasing Blend Operation */
#define	PEXExtPrimAABlendOpImpDep		(PEXEnumTypeIndex) 0x9000
#define	PEXExtPrimAABlendOpSimpleAlpha		(PEXEnumTypeIndex) 0x9001

/* Primitive Anti-Aliasing Blend Operation Mnemonics */
#define	PEXExtETMPrimAABlendOpImpDep		"ExtPrimAABlendOpImpDep"
#define	PEXExtETMPrimAABlendOpSimpleAlpha	"ExtPrimAABlendOpSimpleAlpha"
 
/* Line	Cap Style */
#define	PEXExtLineCapStyleButt			(PEXEnumTypeIndex) 0x9000
#define	PEXExtLineCapStyleRound			(PEXEnumTypeIndex) 0x9001
#define	PEXExtLineCapStyleProjecting		(PEXEnumTypeIndex) 0x9002

/* Line	Cap Style Mnemonics */
#define	PEXExtETMLineCapStyleButt		"ExtLineCapStyleButt"
#define	PEXExtETMLineCapStyleRound		"ExtLineCapStyleRound"
#define	PEXExtETMLineCapStyleProjecting		"ExtLineCapStyleProjecting"
 
/* Line	Join Style */
#define	PEXExtLineJoinStyleImpDep		(PEXEnumTypeIndex) 0x9000
#define	PEXExtLineJoinStyleRound		(PEXEnumTypeIndex) 0x9001
#define	PEXExtLineJoinStyleMiter		(PEXEnumTypeIndex) 0x9002
#define	PEXExtLineJoinStyleBevel		(PEXEnumTypeIndex) 0x9003

/* Line	Join Style Mnemonics */
#define	PEXExtETMLineJoinStyleImpDep		"ExtLineJoinStyleImpDep"
#define	PEXExtETMLineJoinStyleRound		"ExtLineJoinStyleRound"
#define	PEXExtETMLineJoinStyleMiter		"ExtLineJoinStyleMiter"
#define	PEXExtETMLineJoinStyleBevel		"ExtLineJoinStyleBevel"
 
/* Escape */
#define PEXExtEscapeChangePipelineContext       (PEXEnumTypeIndex) 0x9000
#define PEXExtEscapeGetPipelineContext          (PEXEnumTypeIndex) 0x9001
#define PEXExtEscapeChangeRenderer              (PEXEnumTypeIndex) 0x9002
#define PEXExtEscapeGetRendererAttributes       (PEXEnumTypeIndex) 0x9003
#define PEXExtEscapeSetTableEntries             (PEXEnumTypeIndex) 0x9004
#define PEXExtEscapeGetTableEntries             (PEXEnumTypeIndex) 0x9005
#define PEXExtEscapeGetTableEntry               (PEXEnumTypeIndex) 0x9006
#define PEXExtEscapeCreateTM                    (PEXEnumTypeIndex) 0x9007
#define PEXExtEscapeCreateTMDescription         (PEXEnumTypeIndex) 0x9008
#define PEXExtEscapeFreeTM                      (PEXEnumTypeIndex) 0x9009
#define PEXExtEscapeFreeTMDescription           (PEXEnumTypeIndex) 0x900A
#define PEXExtEscapeFetchElements               (PEXEnumTypeIndex) 0x900B
#define PEXExtEscapeQueryColorApprox            (PEXEnumTypeIndex) 0x900C
#define PEXExtEscapeCreateTMExtraData           (PEXEnumTypeIndex) 0x900D

/* Escape Mnemonics */
#define PEXExtETMEscapeChangePipelineContext    "ExtEscapeChangePipelineContext"
#define PEXExtETMEscapeGetPipelineContext       "ExtEscapeGetPipelineContext"
#define PEXExtETMEscapeChangeRenderer           "ExtEscapeChangeRenderer"
#define PEXExtETMEscapeGetRendererAttributes    "ExtEscapeGetRendererAttributes"
#define PEXExtETMEscapeSetTableEntries          "ExtEscapeSetTableEntries"
#define PEXExtETMEscapeGetTableEntries          "ExtEscapeGetTableEntries"
#define PEXExtETMEscapeGetTableEntry            "ExtEscapeGetTableEntry"
#define PEXExtETMEscapeCreateTM                 "ExtEscapeCreateTM"
#define PEXExtETMEscapeCreateTMDescription      "ExtEscapeCreateTMDescription"
#define PEXExtETMEscapeFreeTM                   "ExtEscapeFreeTM"
#define PEXExtETMEscapeFreeTMDescription        "ExtEscapeFreeTMDescription"
#define PEXExtETMEscapeFetchElements            "ExtEscapeFetchElements"
#define PEXExtETMEscapeQueryColorApprox         "ExtEscapeQueryColorApprox"
#define PEXExtETMEscapeCreateTMExtraData        "ExtEscapeCreateTMExtraData"

/* Extended Line Type */
#define	PEXExtLineTypeCenter			(PEXEnumTypeIndex) 0x9000
#define	PEXExtLineTypePhantom			(PEXEnumTypeIndex) 0x9001

/* Extended Line Type Mnemonics	*/
#define	PEXExtETMLineTypeCenter			"ExtLineTypeCenter"
#define	PEXExtETMLineTypePhantom		"ExtLineTypePhantom"
 
/* Hatch Style */
#define	PEXExtHatchStyle45Degrees		(PEXEnumTypeIndex) 0x9000
#define	PEXExtHatchStyle135Degrees		(PEXEnumTypeIndex) 0x9001

/* Hatch Style Mnemonics */
#define	PEXExtETMHatchStyle45Degrees		"ExtHatchStyle45Degrees"
#define	PEXExtETMHatchStyle135Degrees		"ExtHatchStyle135Degrees"
 
/* Interior Style */
#define	PEXExtInteriorStyleTexture		(PEXEnumTypeIndex) 0x9000

/* Interior Style Mnemonics */
#define	PEXExtETMInteriorStyleTexture		"ExtInteriorStyleTexture"

/*
 * Extended Escape Opcodes
 */
#define PEXExtEscapeOpcodeChangePipelineContext 0x80100000
#define PEXExtEscapeOpcodeGetPipelineContext    0x80100001
#define PEXExtEscapeOpcodeChangeRenderer        0x80100002
#define PEXExtEscapeOpcodeGetRendererAttributes 0x80100003
#define PEXExtEscapeOpcodeSetTableEntries       0x80100004
#define PEXExtEscapeOpcodeGetTableEntries       0x80100005
#define PEXExtEscapeOpcodeGetTableEntry         0x80100006
#define PEXExtEscapeOpcodeCreateTM              0x80100007
#define PEXExtEscapeOpcodeCreateTMDescription   0x80100008
#define PEXExtEscapeOpcodeFreeTM                0x80100009
#define PEXExtEscapeOpcodeFreeTMDescription     0x8010000A
#define PEXExtEscapeOpcodeFetchElements         0x8010000B
#define PEXExtEscapeOpcodeQueryColorApprox      0x8010000C
#define PEXExtEscapeOpcodeCreateTMExtraData     0x8010000D

/*
 * Extended facet and vertex attributes	bitmask
 */
#define	PEXExtGAData				(1L<<3)

/*
 * Luminance Channel Selectors
 */
#define	PEXExtChannelRed			0
#define	PEXExtChannelGreen			1
#define	PEXExtChannelBlue			2
#define	PEXExtChannelAlpha			3
#define	PEXExtChannelNTSCLuminance		16

#endif /* PEXEXT_H */

