
/* Common Open Systems Environment, Common Graphics Environment	 */		
/* Extension to	PEX 5.1	version	2.  File date: February	10, 1994 */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN	MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD	TO THIS	      */
/*  SOFTWARE, INCLUDING	ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT	SHALL SUN MICROSYSTEMS,	INC. BE	LIABLE FOR ANY SPECIAL,	      */
/*  INDIRECT OR	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER	RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER	TORTIOUS ACTION, ARISING OUT OF	OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE	OF THIS	SOFTWARE.			      */
/*									      */
/******************************************************************************/

 /* =======================================================================
  * NOTE NOTE NOTE  Insert this	section
  *		    at the end of pl_extract.h file
  * ====================================================================='=
  */
/***** Start of	Ext section ************/

#define	EXTRACT_LISTOF_EXT_VERTEX(_count, _pBuf, _vertexSize, _colorType, _vertFPData, _vertexAttr, _vertexData, _fpConvert, _fpFormat)	\
{ \
    if (_fpConvert) \
    { \
	_PEXExtExtractListOfVertex (_count, &(_pBuf), _colorType, \
	    _vertFPData, _vertexAttr, _vertexData, _fpFormat); \
    } \
    else \
    { \
	int bytes = _count * _vertexSize; \
	COPY_AREA (_pBuf, (char	*) _vertexData.no_data,	bytes);	\
	_pBuf += bytes;	\
    } \
}

#define	EXTRACT_LISTOF_COLOR_APPROX(_count, _pBuf, _pList, _fpConvert, _fpFormat) \
    EXTRACT_LISTOF_FOOFP (pexColorApproxEntry, _count, _pBuf, _pList, \
	_fpConvert, _fpFormat) 

#define	DOEXTRACT_pexColorApproxEntry(_src, _dst, _fpConvert, _fpFormat) \
    _dst.type =	_src->approxType; \
    _dst.model = _src->approxModel; \
    _dst.max1 =	_src->max1; \
    _dst.max2 =	_src->max2; \
    _dst.max3 =	_src->max3; \
    _dst.dither	= _src->dither;	\
    _dst.mult1 = _src->mult1; \
    _dst.mult2 = _src->mult2; \
    _dst.mult3 = _src->mult3; \
    _dst.base_pixel = _src->basePixel; \
    if (_fpConvert) \
    { \
	FP_CONVERT_NTOH	(_src->weight1,	_dst.weight1, _fpFormat); \
	FP_CONVERT_NTOH	(_src->weight2,	_dst.weight2, _fpFormat); \
	FP_CONVERT_NTOH	(_src->weight3,	_dst.weight3, _fpFormat); \
    } \
    else \
    { \
	_dst.weight1 = _src->weight1; \
	_dst.weight2 = _src->weight2; \
	_dst.weight3 = _src->weight3; \
    }

/***** End of Ext section ************/

